---
title: Update Notifications Settings
description: The PUT {{apiPath}}/v1/environments/{{envID}}/notificationsSettings endpoint updates the notifications settings for the specified environment. If an administrator sets a trusted email domain and trusted email address, then the from attribute must be configured to have email notifications sent using the trusted email address. Configuration of the replyTo attribute is optional.
component: pingone-api
page_id: pingone-api:platform:notifications/notifications-settings/update-notifications-settings
canonical_url: https://developer.pingidentity.com/pingone-api/platform/notifications/notifications-settings/update-notifications-settings.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
---

# Update Notifications Settings

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/notificationsSettings
```

The `PUT {{apiPath}}/v1/environments/{{envID}}/notificationsSettings` endpoint updates the notifications settings for the specified environment. If an administrator sets a trusted email domain and trusted email address, then the `from` attribute must be configured to have email notifications sent using the trusted email address. Configuration of the `replyTo` attribute is optional.

This sample shows how to update the `from.address` and `replyTo.address` attribute values to designate trusted email addresses.

|   |                                                                                                                                                                                                                      |
| - | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | If you omit the `from` and `replyTo` attributes from the `PUT` request body, the trusted email address values are removed and the `from` attribute value is reset to the PingOne default `noreply@pingidentity.com`. |

### Prerequisites

* Refer to [Notifications](../../notifications.html) and [Notifications Settings](../notifications-settings.html) for important overview information.

> **Collapse: Request Model**
>
> | Property                           | Type    | Required? |
> | ---------------------------------- | ------- | --------- |
> | `deliveryMode`                     | String  | Required  |
> | `from.address`                     | String  | Optional  |
> | `from.name`                        | String  | Optional  |
> | `replyTo`                          | String  | Optional  |
> | `restrictions.smsVoiceQuote.daily` | Integer | Required  |
> | `smsProvidersFallbackChain`        | String  | Optional  |
> | `whitelist.user.id`                | String  | Required  |
>
> Refer to the [Notifications settings data model](../notifications-settings.html) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "whitelist": [
        {
            "user": {
                "id": "{{userID}}"
            }
        }
    ],
    "smsProvidersFallbackChain": [
        "TwilioPhoneDeliverySettingsId",
        "PINGONE_TWILIO"
    ],
    "deliveryMode": "WHITELIST",
    "from": {
        "name": "noreply",
        "address": "noreply@domain.com"
    },
    "replyTo": {
        "name": "noreply",
        "address": "noreply@domain.com"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/notificationsSettings' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data-raw '{
    "whitelist": [
        {
            "user": {
                "id": "{{userID}}"
            }
        }
    ],
    "smsProvidersFallbackChain": [
        "TwilioPhoneDeliverySettingsId",
        "PINGONE_TWILIO"
    ],
    "deliveryMode": "WHITELIST",
    "from": {
        "name": "noreply",
        "address": "noreply@domain.com"
    },
    "replyTo": {
        "name": "noreply",
        "address": "noreply@domain.com"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/notificationsSettings")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""whitelist"": [" + "\n" +
@"        {" + "\n" +
@"            ""user"": {" + "\n" +
@"                ""id"": ""{{userID}}""" + "\n" +
@"            }" + "\n" +
@"        }" + "\n" +
@"    ]," + "\n" +
@"    ""smsProvidersFallbackChain"": [" + "\n" +
@"        ""TwilioPhoneDeliverySettingsId""," + "\n" +
@"        ""PINGONE_TWILIO""" + "\n" +
@"    ]," + "\n" +
@"    ""deliveryMode"": ""WHITELIST""," + "\n" +
@"    ""from"": {" + "\n" +
@"        ""name"": ""noreply""," + "\n" +
@"        ""address"": ""noreply@domain.com""" + "\n" +
@"    }," + "\n" +
@"    ""replyTo"": {" + "\n" +
@"        ""name"": ""noreply""," + "\n" +
@"        ""address"": ""noreply@domain.com""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings"
  method := "PUT"

  payload := strings.NewReader(`{
    "whitelist": [
        {
            "user": {
                "id": "{{userID}}"
            }
        }
    ],
    "smsProvidersFallbackChain": [
        "TwilioPhoneDeliverySettingsId",
        "PINGONE_TWILIO"
    ],
    "deliveryMode": "WHITELIST",
    "from": {
        "name": "noreply",
        "address": "noreply@domain.com"
    },
    "replyTo": {
        "name": "noreply",
        "address": "noreply@domain.com"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/notificationsSettings HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "whitelist": [
        {
            "user": {
                "id": "{{userID}}"
            }
        }
    ],
    "smsProvidersFallbackChain": [
        "TwilioPhoneDeliverySettingsId",
        "PINGONE_TWILIO"
    ],
    "deliveryMode": "WHITELIST",
    "from": {
        "name": "noreply",
        "address": "noreply@domain.com"
    },
    "replyTo": {
        "name": "noreply",
        "address": "noreply@domain.com"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"whitelist\": [\n        {\n            \"user\": {\n                \"id\": \"{{userID}}\"\n            }\n        }\n    ],\n    \"smsProvidersFallbackChain\": [\n        \"TwilioPhoneDeliverySettingsId\",\n        \"PINGONE_TWILIO\"\n    ],\n    \"deliveryMode\": \"WHITELIST\",\n    \"from\": {\n        \"name\": \"noreply\",\n        \"address\": \"noreply@domain.com\"\n    },\n    \"replyTo\": {\n        \"name\": \"noreply\",\n        \"address\": \"noreply@domain.com\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/notificationsSettings")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "whitelist": [
      {
        "user": {
          "id": "{{userID}}"
        }
      }
    ],
    "smsProvidersFallbackChain": [
      "TwilioPhoneDeliverySettingsId",
      "PINGONE_TWILIO"
    ],
    "deliveryMode": "WHITELIST",
    "from": {
      "name": "noreply",
      "address": "noreply@domain.com"
    },
    "replyTo": {
      "name": "noreply",
      "address": "noreply@domain.com"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/notificationsSettings',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "whitelist": [
      {
        "user": {
          "id": "{{userID}}"
        }
      }
    ],
    "smsProvidersFallbackChain": [
      "TwilioPhoneDeliverySettingsId",
      "PINGONE_TWILIO"
    ],
    "deliveryMode": "WHITELIST",
    "from": {
      "name": "noreply",
      "address": "noreply@domain.com"
    },
    "replyTo": {
      "name": "noreply",
      "address": "noreply@domain.com"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings"

payload = json.dumps({
  "whitelist": [
    {
      "user": {
        "id": "{{userID}}"
      }
    }
  ],
  "smsProvidersFallbackChain": [
    "TwilioPhoneDeliverySettingsId",
    "PINGONE_TWILIO"
  ],
  "deliveryMode": "WHITELIST",
  "from": {
    "name": "noreply",
    "address": "noreply@domain.com"
  },
  "replyTo": {
    "name": "noreply",
    "address": "noreply@domain.com"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/notificationsSettings');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "whitelist": [\n        {\n            "user": {\n                "id": "{{userID}}"\n            }\n        }\n    ],\n    "smsProvidersFallbackChain": [\n        "TwilioPhoneDeliverySettingsId",\n        "PINGONE_TWILIO"\n    ],\n    "deliveryMode": "WHITELIST",\n    "from": {\n        "name": "noreply",\n        "address": "noreply@domain.com"\n    },\n    "replyTo": {\n        "name": "noreply",\n        "address": "noreply@domain.com"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/notificationsSettings")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "whitelist": [
    {
      "user": {
        "id": "{{userID}}"
      }
    }
  ],
  "smsProvidersFallbackChain": [
    "TwilioPhoneDeliverySettingsId",
    "PINGONE_TWILIO"
  ],
  "deliveryMode": "WHITELIST",
  "from": {
    "name": "noreply",
    "address": "noreply@domain.com"
  },
  "replyTo": {
    "name": "noreply",
    "address": "noreply@domain.com"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"whitelist\": [\n        {\n            \"user\": {\n                \"id\": \"{{userID}}\"\n            }\n        }\n    ],\n    \"smsProvidersFallbackChain\": [\n        \"TwilioPhoneDeliverySettingsId\",\n        \"PINGONE_TWILIO\"\n    ],\n    \"deliveryMode\": \"WHITELIST\",\n    \"from\": {\n        \"name\": \"noreply\",\n        \"address\": \"noreply@domain.com\"\n    },\n    \"replyTo\": {\n        \"name\": \"noreply\",\n        \"address\": \"noreply@domain.com\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```
